﻿Imports globalefunktionen

Partial Class WebParts_Vorgang_HalloWeltTreeViewMP 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem Bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

#Region " Seitenspezifisches "

    Protected Sub JQueryTreeview_NodeMovedCrossTreeview(sender As Object, e As JQueryTreeview.TreeEventArgs) Handles JQueryTreeview.NodeMovedCrossTreeview
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)
        Dim matbMenge, matbArtikel As JQueryTreeview.TextboxEntry
        Dim VorgangsPosition As Klassen.clsVorgangsPositionClient
        Dim Adresse As Klassen.clsAdresse
        Dim Artikel As Klassen.clsArtikel
        Dim FehlerText As String
        Dim ArtikelID As Integer
        Dim Menge As Integer

        JQueryTreeview.SaveLastAction(Nothing) '            <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ModalPopup: "Event"-Speicher leeren
        JQueryTreeview.SaveTrunkToSession() '               <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ModalPopup: Speichern
        JQueryTreeview.AbortMove = True

        Select Case e.DroppedNode.CustomType
            Case eCustomNodeTyp.Adresse
                If e.SourceTreeID = JQueryTreeviewToolbox.ID AndAlso e.NewParentNode.CustomType = eCustomNodeTyp.KundenAdresseParent Then
                    Adresse = New Klassen.clsAdresse(CInt(e.DroppedNode.CustomID))
                    FehlerText = Vorgang.UeberpruefeObAdresseHinzufuegenErlaubt(Adresse)
                    If FehlerText = "" Then
                        Vorgang.AdresseHinzufuegen(Adresse)
                    End If

                    e.NewParentNode.Clear()
                    AdresseLaden(e.NewParentNode)
                    JQueryTreeview.RebuildTreeView()
                End If
            Case eCustomNodeTyp.Position, eCustomNodeTyp.Artikel
                If e.NewParentNode.CustomType = eCustomNodeTyp.PositionParent Then
                    Artikel = Nothing

                    If e.SourceTreeID = JQueryTreeviewToolbox.ID Then
                        Artikel = New Klassen.clsArtikel(CInt(e.DroppedNode.CustomID))

                        '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<ModalPopup>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        If GetLastEvent().EventOverride = False Then
                            SetLastEvent(New LastEvent(e, LastEvent.eEventTyp.NodeMoveCrossTreeview)) 'Die "Event"-Daten speichern
                            mampTextBox.Caption = ArtikelmengePopup
                            mampTextBox.Parameter = New Object() {Nothing, False, "Artikelmenge:"}
                            mampTextBox.Show() 'Popup anzeigen
                            Exit Sub
                        Else
                            Menge = GetLastEvent().EventArtikelmenge
                        End If
                        '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>ModalPopup<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                    ElseIf e.SourceTreeID = JQueryTreeviewNeu.ID Then
                        matbArtikel = e.DroppedNode.GetTextbox("matbArtikel")
                        matbMenge = e.DroppedNode.GetTextbox("matbMenge")
                        If Not matbArtikel.Value = "" AndAlso Not matbMenge.Value = "" AndAlso IsNumeric(matbMenge.Value) = True Then
                            ArtikelID = matbArtikel.Value.Substring(matbArtikel.Value.LastIndexOf("(") + 1, matbArtikel.Value.Length - matbArtikel.Value.LastIndexOf("(") - 2)
                            Artikel = New Klassen.clsArtikel(ArtikelID)
                            Menge = matbMenge.Value
                        End If
                    End If

                    SetLastEvent(New LastEvent()) '         <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ModalPopup: "Event"-Speicher leeren

                    If Not Artikel Is Nothing AndAlso Klassen.clsFunktionen.ExistenzUeberpruefung(Artikel) = True Then
                        VorgangsPosition = New Klassen.clsVorgangsPositionClient
                        VorgangsPosition.VorgangClient = Me.KlassenObjekt
                        VorgangsPosition.Position = Vorgang.VorgangsPositionen.Count
                        VorgangsPosition.ArtikelHinzufuegen(Artikel)
                        VorgangsPosition.Artikelmenge = globalefunktionen.IsDouble(Menge)

                        If e.AddedToEnd = False Then
                            For i = e.NewIndex To e.NewParentNode.ChildNodes.Count - 1
                                VorgangsPosition.PositionHoch()
                            Next
                        End If

                        '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<ModalPopup>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        'Normalerweise reicht dieser Quellcode, durch das Popup muss die Parentnode aktuell anhand der ID neu gesucht werden:
                        'e.NewParentNode.Clear()
                        'PositionenLaden(e.NewParentNode)

                        JQueryTreeview.ChildNodes(JQueryTreeview.FindChildNodeByID(e.NewParentNode.ID)).Clear()
                        PositionenLaden(JQueryTreeview.ChildNodes(JQueryTreeview.FindChildNodeByID(e.NewParentNode.ID)))
                        '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>ModalPopup<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                    End If

                    If e.SourceTreeID = JQueryTreeviewToolbox.ID Then
                        JQueryTreeview.RebuildTreeView()
                    End If
                End If
        End Select

        If e.SourceTreeID = JQueryTreeviewNeu.ID Then
            JQueryTreeviewNeu.Reset()
            GenerateTreeviewNeu()
            JQueryTreeviewNeu.RebuildTreeView()
        End If
    End Sub

#End Region

    '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<ModalPopup>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
#Region " Neue Funktionen/Prozeduren/Variablen in diesem Besipiel "

    Private Const ArtikelmengePopup As String = "Position hinzufügen:" 'Die Überschrift des Popups wird benutzt um festzustellen welches Popup ein bestimmtes "Event" gesendet hat

    ''' <summary>
    ''' In dieser Klasse werden die mit dem Ursprünglichen, durch das Popup unterbrochenen, "Event" verbundenen Daten gespeichert. Zusätzlich wird die Eingabe des Benutzers hier zwischengespeichert
    ''' </summary>
    ''' <remarks></remarks>
    <Serializable()>
    Private Class LastEvent
        Public LastEventargs As JQueryTreeview.TreeEventArgs
        Public EventTyp As eEventTyp
        Public EventOverride As Boolean
        Public EventArtikelmenge As Double
        Public Enum eEventTyp
            none = 0
            NodeClicked = 1
            NodeMove = 2
            NodeMoveCrossTreeview = 3
        End Enum
        Public Sub New(Optional ByVal lLastEventargs As JQueryTreeview.TreeEventArgs = Nothing, Optional ByVal eEventTyp As eEventTyp = LastEvent.eEventTyp.none, Optional ByVal eEventOverride As Boolean = False)
            If lLastEventargs IsNot Nothing Then LastEventargs = lLastEventargs
            EventTyp = eEventTyp
            EventOverride = eEventOverride
        End Sub
    End Class

    'Speichert das "Event" in der Session und läd es wieder
    Private Sub SetLastEvent(ByVal LastEvent As LastEvent)
        Session.Add(Page.GetType().Name & JQueryTreeview.ClientID & "MAMPLastEvent____", LastEvent)
    End Sub
    Private Function GetLastEvent() As LastEvent
        Try
            Dim LastEvent As LastEvent = Session.Item(Page.GetType().Name & JQueryTreeview.ClientID & "MAMPLastEvent____")
            If LastEvent Is Nothing Then
                Return New LastEvent
            Else
                Return LastEvent
            End If
        Catch ex As Exception
            Return New LastEvent
        End Try
    End Function


    Protected Sub mampTextBox_Ok(sender As Object, e As System.EventArgs) Handles mampTextBox.Ok
        If mampTextBox Is Nothing Then
            Exit Sub
        End If

        Dim LastEvent As LastEvent = GetLastEvent()
        If Not LastEvent Is Nothing Then
            If mampTextBox.Caption = ArtikelmengePopup AndAlso LastEvent.LastEventargs IsNot Nothing Then
                LastEvent.EventOverride = True 'Das Popup nicht erneut anzeigen

                If IsNumeric(mampTextBox.Response(0).ToString) = True Then
                    LastEvent.EventArtikelmenge = mampTextBox.Response(0).ToString 'Die Benutzereingabe an das "Event" schreiben
                End If

                SetLastEvent(LastEvent)
                Select Case LastEvent.EventTyp
                    Case LastEvent.eEventTyp.NodeMoveCrossTreeview
                        JQueryTreeview_NodeMovedCrossTreeview(JQueryTreeview, LastEvent.LastEventargs) 'Das Ursprüngliche, durch das Popup unterbrochene, "Event" erneut ausführen
                End Select
            End If
        End If
    End Sub

    Protected Sub mampTextBox_Abort(sender As Object, e As System.EventArgs) Handles mampTextBox.Abort
        JQueryTreeview.RebuildTreeView()
    End Sub

#End Region
    '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>ModalPopup<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

#Region " In diesem Beispiel nicht relevant "

#Region " Enumeratoren "

    ''' <summary>
    ''' Ein eigener Enumerator ist eine einfache Möglichkeit über den "CustomType" der "Treeview-Nodes" die verschiedenen Arten von "Nodes" bei "Events" zu unterscheiden
    ''' </summary>
    ''' <remarks></remarks>
    Private Enum eCustomNodeTyp
        None = 0
        Artikel = 1
        Adresse = 2
        Position = 3
        PositionParent = 4
        KundenAdresseParent = 5
        ArtikelParent = 6
    End Enum

#End Region

#Region " Eigenschaften "

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "Fortgeschritten - 07 JQueryTreeview - ModalPopup"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return ""
        End Get
    End Property

#End Region

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()
    End Sub

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub SaveDataToKlassenObjekt()
    End Sub

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
    End Sub

#Region " Seitenspezifisches "

    ''' <summary>
    ''' Hier werden, falls nötig, die drei Treeviews initialisiert
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub Page_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
        If JQueryTreeview.Initialized = False Then
            JQueryTreeview.Reset()
            TreeviewLaden()
            JQueryTreeview.Initialized = True
        End If
        If JQueryTreeviewToolbox.Initialized = False Then
            JQueryTreeviewToolbox.Reset()
            TreeviewToolboxLaden()
            JQueryTreeviewToolbox.Initialized = True
        End If
        If JQueryTreeviewNeu.Initialized = False Then
            JQueryTreeviewNeu.Reset()
            GenerateTreeviewNeu()
            JQueryTreeviewNeu.Initialized = True
        End If
    End Sub

    ''' <summary>
    ''' Dieses "Event" wird ausgelöst wenn ein "Button" einer "Node" im Treeview "JQueryTreeview" geklickt wird
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub JQueryTreeview_NodeClicked(sender As Object, e As JQueryTreeview.TreeEventArgs) Handles JQueryTreeview.NodeClicked
        Dim Position As Klassen.clsVorgangsPositionClient
        Dim matbMenge As JQueryTreeview.TextboxEntry
        If Not Me.Gesperrt Then
            Select Case e.ClickedButton '                                                                   Diese variable enthält die ID des Buttons, der geklickt wurde
                Case "MyLinkButtonEditieren" '                                                              Dieser "Button" soll im Beispiel das "Template" der "Node" auf "Selected" wechseln
                    If e.ClickedNode.CustomType = eCustomNodeTyp.Position Then '                            Falls die geklickte "Node" eine Position ist
                        JQueryTreeview.Editmode = False '                                                   Schaltet alle Verschiebeaktionen für den Treeview ab, um das editieren zu vereinfachen, ist nicht zwangsläufig erforderlich aber Benutzerfreundlicher
                        JQueryTreeview.TreeTrunk.SelectedNodeID = e.ClickedNode.ID '                        markiert die geklickte "Node" als "Selected"
                        JQueryTreeview.RebuildTreeView() '                                                  Erstellt den Treeview mit den aktuellen Werten neu. ACHTUNG! löst einen Postback aus
                    End If
                Case "MyLinkButtonAbbrechen"
                    If e.ClickedNode.CustomType = eCustomNodeTyp.Position Then '                            Falls die geklickte "Node" eine Position ist
                        JQueryTreeview.Editmode = True '                                                    Schaltet alle Verschiebeaktionen für den Treeview wieder ein
                        JQueryTreeview.TreeTrunk.SelectedNodeID = -1 '                                      Hebt die Markierung der Node auf
                        JQueryTreeview.RebuildTreeView() '                                                  Erstellt den Treeview mit den aktuellen Werten neu. ACHTUNG! löst einen Postback aus
                    End If
                Case "MyLinkButtonSpeichern"
                    If e.ClickedNode.CustomType = eCustomNodeTyp.Position Then '                            Falls die geklickte "Node" eine Position ist
                        Position = New Klassen.clsVorgangsPositionClient(e.ClickedNode.CustomID)

                        matbMenge = e.ClickedNode.GetTextbox("matbMenge")
                        If Not matbMenge.Value = "" AndAlso IsNumeric(matbMenge.Value) = True Then
                            e.ClickedNode.SetLabel("lMenge", matbMenge.Value)
                            e.ClickedNode.SetTextbox("matbMenge", matbMenge.Value)

                            Position.Artikelmenge = matbMenge.Value
                        End If

                        JQueryTreeview.Editmode = True
                        JQueryTreeview.TreeTrunk.SelectedNodeID = -1 '                                      Hebt die Markierung der Node auf
                        JQueryTreeview.RebuildTreeView() '                                                  Erstellt den Treeview mit den aktuellen Werten neu. ACHTUNG! löst einen Postback aus
                    End If
                Case "MyLinkButtonDelete"
                    If e.ClickedNode.CustomType = eCustomNodeTyp.Position Then '                            Falls die geklickte "Node" eine Position ist
                        Position = New Klassen.clsVorgangsPositionClient(e.ClickedNode.CustomID)
                        Position.Loeschen()

                        e.ParentNode.removeTreeNode(e.ClickedNode)
                        JQueryTreeview.RebuildTreeView() '                                                  Erstellt den Treeview mit den aktuellen Werten neu. ACHTUNG! löst einen Postback aus
                    End If
            End Select
        End If
    End Sub

    ''' <summary>
    ''' Eine neue "Node" über den "Neu-Button" anlegen:
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub JQueryTreeviewNeu_NodeClicked(sender As Object, e As JQueryTreeview.TreeEventArgs) Handles JQueryTreeviewNeu.NodeClicked
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)
        Dim VorgangsPosition As Klassen.clsVorgangsPositionClient
        Dim matbMenge, matbArtikel As JQueryTreeview.TextboxEntry
        Dim ArtikelID As Integer
        Dim Artikel As Klassen.clsArtikel
        Dim PositionsNode As JQueryTreeview.myTreeNode
        Select Case e.ClickedButton
            Case "MyLinkButtonNeu"
                If e.ClickedNode.CustomType = eCustomNodeTyp.Position Then
                    matbArtikel = e.ClickedNode.GetTextbox("matbArtikel")
                    matbMenge = e.ClickedNode.GetTextbox("matbMenge")
                    If Not matbArtikel.Value = "" AndAlso matbArtikel.Value.Contains("(") = True AndAlso Not matbMenge.Value = "" AndAlso IsNumeric(matbMenge.Value) = True Then
                        'Den String der Textbox parsen um an die ArtikelID zu kommen:
                        ArtikelID = matbArtikel.Value.Substring(matbArtikel.Value.LastIndexOf("(") + 1, matbArtikel.Value.Length - matbArtikel.Value.LastIndexOf("(") - 2)
                        Artikel = New Klassen.clsArtikel(ArtikelID)
                        If Klassen.clsFunktionen.ExistenzUeberpruefung(Artikel) = True Then
                            VorgangsPosition = New Klassen.clsVorgangsPositionClient
                            VorgangsPosition.VorgangClient = Me.KlassenObjekt
                            VorgangsPosition.Position = Vorgang.VorgangsPositionen.Count
                            VorgangsPosition.ArtikelHinzufuegen(Artikel)
                            VorgangsPosition.Artikelmenge = globalefunktionen.IsDouble(matbMenge.Value)

                            'Der einfache Weg ist den Treeview neu zu laden: (Es ist aber ebenso möglich die "Node" manuell hinzuzufügen oder auch zu löschen)
                            If JQueryTreeview.ChildNodes.Count > 0 AndAlso JQueryTreeview.ChildNodes(0).CustomType = eCustomNodeTyp.PositionParent Then
                                PositionsNode = JQueryTreeview.ChildNodes(0) '                          Die "PositionsParentnode" laden
                                PositionsNode.Clear() '                                                 leeren
                                PositionenLaden(PositionsNode) '                                        neu laden
                            Else
                                JQueryTreeview.Reset() '                                                Der "Haupt-Treeview" wird zurückgesetzt
                                TreeviewLaden() '                                                       Der "Haupt-Treeview" wird neu generiert um alle Werte korrekt zu setzen
                            End If

                            JQueryTreeviewNeu.Reset() '                                                 Der "Treeview-Neu" wird zurückgesetzt
                            GenerateTreeviewNeu() '                                                     Der "Treeview-Neu" wird neu generiert um alle Werte korrekt zu setzen
                            JQueryTreeviewNeu.RebuildTreeView() '                                       Erstellt den Treeview mit den aktuellen Werten neu. ACHTUNG! löst einen Postback aus
                        End If
                    End If
                End If
        End Select
    End Sub

    ''' <summary>
    ''' Erst bei einem klick auf "Nodes laden" werden die Adressen geladen und an die geklickte "Node" gehangen
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Sub JQueryTreeviewToolbox_NodeClicked(sender As Object, e As JQueryTreeview.TreeEventArgs) Handles JQueryTreeviewToolbox.NodeClicked
        Dim tmpnode As JQueryTreeview.myTreeNode
        Dim Table As Data.DataTable
        Dim Adresse As Klassen.clsAdresse
        Select Case e.ClickedButton
            Case "MyLinkButtonNodesLaden"
                If e.ClickedNode.CustomType = eCustomNodeTyp.KundenAdresseParent Then
                    Table = Klassen.clsFunktionen.GetList(New Data.SqlClient.SqlCommand("SELECT ID FROM Adresse ORDER BY ID DESC LIMIT 30"))
                    If Table IsNot Nothing AndAlso Table.Rows.Count > 0 Then
                        For Each Row As Data.DataRow In Table.Rows
                            Adresse = New Klassen.clsAdresse(CInt(Row.Item("ID")))
                            tmpnode = New JQueryTreeview.myTreeNode(Adresse.Name1 & " " & Adresse.Name2, CInt(Row.Item("ID")))
                            tmpnode.CustomType = eCustomNodeTyp.Adresse
                            tmpnode.AcceptsNodes = False
                            tmpnode.IconImage = "App_Themes/Main/Bilder/JQueryTreeview/Report.png"
                            tmpnode.CSSClass = "treeItemHoverHighlight"

                            If Me.Gesperrt Then
                                tmpnode.Draggable = False
                            End If
                            e.ClickedNode.addTreeNode(tmpnode)
                        Next

                        JQueryTreeviewToolbox.RebuildTreeView() '                                       Erstellt den Treeview mit den aktuellen Werten neu. ACHTUNG! löst einen Postback aus
                    End If
                End If
        End Select
    End Sub

#End Region

#Region " Prozeduren "

    Private Sub TreeviewLaden()
        InhaltHauptTreeviewLaden()

        JQueryTreeview.Editmode = True '                                                                "Treeview-Nodes" können verschoben werden
        JQueryTreeview.TreeTrunk.AcceptsNodes = True '                                                  Der Treeview aktzeptiert "Nodes"
        JQueryTreeview.TreeTrunk.AllowCrossTreeviewDrops = True '                                       Der Treeview aktzeptiert "Nodes" anderer Treeviews und lässt zu das die eigenen Nodes in andere Treeviews gezogen werden können, die "Nodes" müssen manuell gefiltert werden, mehr dazu im "Event" "JQueryTreeview_NodeMovedCrossTreeview"
        JQueryTreeview.TreeTrunk.InsertSpacerNode = True '                                              Fügt bei "Nodes", welche keine "Nodes" aktzeptieren, Zwischenräume ein, so dass diese den gleichen Abstand wie andere "Nodes" haben
        JQueryTreeview.SaveTrunkToSession() '                                                           Speichert den aktuellen Zustand in die Session
    End Sub

    Public Sub GenerateTreeviewNeu()
        Dim ArtikelNode As JQueryTreeview.myTreeNode

        If Not Me.Gesperrt Then
            ArtikelNode = New JQueryTreeview.myTreeNode("") '                                           Diese "Node" hat keine Beschreibung
            ArtikelNode.CustomType = eCustomNodeTyp.Position '                                          Der "CustomType" wird nur zum speichern von Informationen bereitgestellt (z.B. um herauszufinden welche "Node" verschoben oder angeklickt wurde
            ArtikelNode.SetTextbox("matbMenge", "1") '                                                  Ausgangswert für die Menge setzen
            ArtikelNode.SetTextbox("matbArtikel", "") '                                                 Ausgangswert für die Artikeleingabe setzen
            JQueryTreeviewNeu.TreeTrunk.addTreeNode(ArtikelNode) '                                      Fügt die "Node" dem Treeview auf der ersten Ebene (im Stamm) hinzu
        End If
        JQueryTreeviewNeu.Editmode = True
        JQueryTreeviewNeu.AllowCrossTreeviewDrops = True '                                              Der Treeview aktzeptiert "Nodes" anderer Treeviews und lässt zu das die eigenen Nodes in andere Treeviews gezogen werden können
        JQueryTreeviewNeu.InsertSpacerNode = True '                                                     Fügt bei "Nodes", welche keine "Nodes" aktzeptieren, Zwischenräume ein, so dass diese den gleichen Abstand wie andere "Nodes" haben
        JQueryTreeviewNeu.DisableDrops = True '                                                         Der Treeview aktzeptiert keine "Nodes"
        JQueryTreeviewNeu.SaveTrunkToSession() '                                                        Speichert den aktuellen Zustand in die Session
    End Sub

    Private Sub TreeviewToolboxLaden()
        ToolboxLaden(JQueryTreeviewToolbox.TreeTrunk)

        JQueryTreeviewToolbox.Editmode = True '                                                         "Treeview-Nodes" können verschoben werden
        JQueryTreeviewToolbox.TreeTrunk.AllowCrossTreeviewDrops = True '                                Der Treeview aktzeptiert "Nodes" anderer Treeviews und lässt zu das die eigenen Nodes in andere Treeviews gezogen werden können
        JQueryTreeviewToolbox.TreeTrunk.DisableDropsTree = True '                                       Der Treeview aktzeptiert keine "Nodes"
        JQueryTreeviewToolbox.SaveTrunkToSession() '                                                    Speichert den aktuellen Zustand in die Session
    End Sub

    Private Sub InhaltHauptTreeviewLaden()
        Dim parentnode As JQueryTreeview.myTreeNode

        parentnode = New JQueryTreeview.myTreeNode("")
        parentnode.TemplateTyp = Global.JQueryTreeview.myTreeNode.eTemplateTyp.Template1 '              Über das Template lässt dich die Gestaltung der Node wählen
        parentnode.CustomType = eCustomNodeTyp.PositionParent '                                         Der "CustomType" wird nur zum speichern von Informationen bereitgestellt (z.B. um herauszufinden welche "Node" verschoben oder angeklickt wurde
        parentnode.Draggable = False '                                                                  Diese "Node" ist nicht verschiebbar
        parentnode.AcceptsNodes = True '                                                                Diese "Node" aktzeptiert "Nodes"
        parentnode.CloseNode = False '                                                                  Diese "Node" ist ausgeklappt

        PositionenLaden(parentnode)

        JQueryTreeview.TreeTrunk.addTreeNode(parentnode)

        parentnode = New JQueryTreeview.myTreeNode("Kundenadresse")
        parentnode.CustomType = eCustomNodeTyp.KundenAdresseParent '                                    Der "CustomType" wird nur zum speichern von Informationen bereitgestellt (z.B. um herauszufinden welche "Node" verschoben oder angeklickt wurde
        parentnode.Draggable = False '                                                                  Diese "Node" ist nicht verschiebbar
        parentnode.AcceptsNodes = True '                                                                Diese "Node" aktzeptiert "Nodes"
        parentnode.CloseNode = False '                                                                  Diese "Node" ist ausgeklappt

        AdresseLaden(parentnode)

        JQueryTreeview.TreeTrunk.addTreeNode(parentnode)
    End Sub

    Private Sub PositionenLaden(ByVal parentnode As JQueryTreeview.myTreeNode)
        Dim Table As Data.DataTable
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)
        Dim VorgangsPosition As Klassen.clsVorgangsPositionClient
        Dim Artikel As Klassen.clsArtikel
        Dim tmpnode As JQueryTreeview.myTreeNode

        'Die Positionen aus der Datenbank auslesen:
        Table = Klassen.clsFunktionen.GetList(New Data.SqlClient.SqlCommand("SELECT ID, Artikel_ID, Artikelmenge, Position FROM VorgangsPositionClient WHERE NOT Artikel_ID IS NULL AND VorgangClientID = " & Vorgang.ID & " ORDER BY Position ASC"))
        If Table IsNot Nothing AndAlso Table.Rows.Count > 0 Then
            For Each Row As Data.DataRow In Table.Rows
                VorgangsPosition = New Klassen.clsVorgangsPositionClient(CInt(Row.Item("ID")))
                Artikel = New Klassen.clsArtikel(CInt(Row.Item("Artikel_ID")))
                'Erstellt eine neue "Node" mit der PositionsID als "CustomID", die "CustomID" hat für den Treeview selbst keine Funktion und wird wie der "CustomType" nur zum speichern von Informationen bereitgestellt (z.B. um herauszufinden welche "Node" verschoben oder angeklickt wurde
                tmpnode = New JQueryTreeview.myTreeNode("", CInt(Row.Item("ID")))
                tmpnode.CustomType = eCustomNodeTyp.Position
                tmpnode.AcceptsNodes = False
                tmpnode.Draggable = True

                If parentnode.ChildNodes Is Nothing OrElse parentnode.ChildNodes.Count Mod 2 = 0 Then
                    tmpnode.TemplateTyp = Global.JQueryTreeview.myTreeNode.eTemplateTyp.Template2
                Else
                    tmpnode.TemplateTyp = Global.JQueryTreeview.myTreeNode.eTemplateTyp.Template3
                End If

                tmpnode.SetLabel("lArtikel", Artikel.Kurztext) '                                        Setzt den Text des Labels "lArtikel" des zugewiesenen Templates an dieser "Node"
                If Not Row.Item("Artikelmenge") Is System.DBNull.Value Then
                    tmpnode.SetLabel("lMenge", Row.Item("Artikelmenge"))
                    tmpnode.SetTextbox("matbMenge", Row.Item("Artikelmenge"))
                Else
                    tmpnode.SetLabel("lMenge", "")
                    tmpnode.SetTextbox("matbMenge", "")
                End If

                If Me.Gesperrt Then
                    tmpnode.Draggable = False
                    tmpnode.SetLinkButton("MyLinkButtonEditieren", False, True)
                    tmpnode.SetLinkButton("MyLinkButtonDelete", False, True)
                End If
                parentnode.addTreeNode(tmpnode)
            Next
        End If
    End Sub

    Private Sub AdresseLaden(ByVal parentnode As JQueryTreeview.myTreeNode)
        Dim Vorgang As Klassen.clsVorgangClient = TryCast(Me.KlassenObjekt, Klassen.clsVorgangClient)
        Dim Adresse As Klassen.clsAdresse
        Dim tmpnode As JQueryTreeview.myTreeNode

        If Not Vorgang.Adresse_ID = 0 Then
            Adresse = New Klassen.clsAdresse(Vorgang.Adresse_ID)
            tmpnode = New JQueryTreeview.myTreeNode(Adresse.Name1 & " " & Adresse.Name2, Adresse.ID)
            tmpnode.CustomType = eCustomNodeTyp.Adresse
            tmpnode.AcceptsNodes = False
            tmpnode.IconImage = "App_Themes/Main/Bilder/JQueryTreeview/Report.png" '                    'Setzt das "Icon", welches vor der "Node" eingeblendet wird
            tmpnode.Draggable = False

            parentnode.addTreeNode(tmpnode)
        End If
    End Sub

    Private Sub ToolboxLaden(ByRef node As JQueryTreeview.myTreeNode)
        Dim tmpnode, parentnode As JQueryTreeview.myTreeNode
        Dim Table As Data.DataTable
        Dim Artikel As Klassen.clsArtikel

        parentnode = New JQueryTreeview.myTreeNode("Artikel", 1)
        parentnode.CustomType = eCustomNodeTyp.ArtikelParent
        parentnode.Draggable = False
        parentnode.AcceptsNodes = False
        parentnode.CloseNode = True

        'Läd die ersten 30 Artikel:
        Table = Klassen.clsFunktionen.GetList(New Data.SqlClient.SqlCommand("SELECT ID FROM Artikel ORDER BY ID DESC LIMIT 30"))
        If Table IsNot Nothing AndAlso Table.Rows.Count > 0 Then
            For Each Row As Data.DataRow In Table.Rows
                Artikel = New Klassen.clsArtikel(CInt(Row.Item("ID")))
                tmpnode = New JQueryTreeview.myTreeNode(Artikel.Kurztext, CInt(Row.Item("ID")))
                tmpnode.CustomType = eCustomNodeTyp.Artikel
                tmpnode.AcceptsNodes = False
                tmpnode.IconImage = "App_Themes/Main/Bilder/JQueryTreeview/artikel.png"
                tmpnode.CSSClass = "treeItemHoverHighlight" '                                           Hebt die "Node" hervor, wenn die Maus darüber bewegt wird

                If Me.Gesperrt Then
                    tmpnode.Draggable = False
                End If
                parentnode.addTreeNode(tmpnode)
            Next
        End If
        node.addTreeNode(parentnode)

        parentnode = New JQueryTreeview.myTreeNode("Adressen", 1)
        parentnode.CustomType = eCustomNodeTyp.KundenAdresseParent
        parentnode.TemplateTyp = Global.JQueryTreeview.myTreeNode.eTemplateTyp.Template1
        parentnode.Draggable = False
        parentnode.AcceptsNodes = False
        parentnode.CloseNode = True

        'Dieser Inhalt wird über einen Button geladen, siehe "JQueryTreeviewToolbox_NodeClicked"

        node.addTreeNode(parentnode)
    End Sub

#End Region

#End Region

End Class