<%@ Control Language="VB" AutoEventWireup="false" CodeFile="HalloWeltTB.ascx.vb" Inherits="WebParts_Vorgang_HalloWeltTB" %> <%--CodeFile: muss auf die Quellcodedatei dieser Datei zeigen, Inherits: muss mit der Klasse in der Quellcodedatei bereinstimmen --%>
<%@ Register Assembly="myWebControls" Namespace="myWebControls" TagPrefix="cc1" %>                                          <%--Importiert die UniERM Steuerelemente--%>

<div class="w35 left">
    <span class="first">
        <asp:Label ID="lBezeichnung" runat="server" Text="Bezeichnung:"></asp:Label>
    </span>

    <asp:Label ID="lAdresse" runat="server" Text="Adresse (Test):"></asp:Label>
    <asp:Label ID="lReferenzAdresse" runat="server" Text="Referenzadresse (Test):"></asp:Label>

    <asp:Label ID="lTermin" runat="server" Text="Termin:"></asp:Label>

    <span class="last">
        <asp:Label ID="lLieferziel" runat="server" Text="Lieferziel:"></asp:Label>
    </span>
</div>

<div class="w65 right">
    <div class="row first">
        <%--/////////Einfache Textbox\\\\\\\\\--%>
        <cc1:MyAJAXTextBox ID="matbBezeichnung" runat="server" DivWithFakeBorder="True" />
    </div>

    <div class="row">
        <%--/////////Autocomplete Textbox mit allen Adressen\\\\\\\\\--%>
        <cc1:MyAJAXTextBox ID="matbAdresse" runat="server" SkinID="AutoComplete" ServiceMethod="GetKunden" DivWithFakeBorder="True" />
        <%--/////////Aktuelle Funktionen\\\\\\\\\--%>
        <%--GetOrte                 (Allgemein)--%>
        <%--GetKunden               (Allgemein)--%>
        <%--GetArtikel              (Allgemein)--%>
        <%--GetVorgaenge            (Allgemein)--%>
        <%--GetLieferadressen       (Parameter: "SprachID|AddressID")--%>
        <%--GetAnsprechpartner      (Parameter: "SprachID|AddressID")--%>
        <%--GetVorgangsadressen     (Allgemein)--%>
        <%--GetReferenzadressen     (Parameter: "SprachID|AddressID")--%>
        <%--GetRechnungsadressen    (Parameter: "SprachID|AddressID")--%>
        <%--//Siehe Pageload fr Parameterbergabe--%>
    </div>
    <div class="row">
        <%--/////////Autocomplete Textbox mit allen Referenzadressen einer Adresse (Siehe Pageload fr Parameterbergabe)\\\\\\\\\--%>
        <cc1:MyAJAXTextBox ID="matbReferenzAdresse" runat="server" SkinID="AutoComplete" ServiceMethod="GetReferenzadressen" DivWithFakeBorder="True" />
    </div>

    <div class="row">
        <%--/////////Textbox mit Datumseingabe\\\\\\\\\--%>
        <cc1:MyAJAXTextBox ID="matbTermin" runat="server" SkinID="Date" DivWithFakeBorder="True" />		<%--Diese Textbox wird durch den "Skin" "Date" zusammen mit einer Datumsauswahl angezeigt und lsst zudem nur Datumswerte zu--%>
    </div>                                                                                              <%--Die "Skins" lassen sich fr die Textbox unter "\App_Themes\Main\myAJAXTextBox.skin" finden--%>

    <div class="row last">
        <%--/////////Kurze Textbox mit extra Beschriftung\\\\\\\\\--%>
        <asp:Panel ID="pLieferziel" runat="server" CssClass="TBDefault TBText">
            <div class="TBDefault_Right">
                <div class="TBDefault_Middle">
                    <cc1:MyAJAXTextBox ID="matbLieferziel" runat="server" Width="50" SkinID="Double" />
                    <asp:Label ID="lTageLieferziel" runat="server" Text="Tage" SkinID="NoCssClass"></asp:Label>
                </div>
            </div>
        </asp:Panel>
    </div>
</div>
