<%@ Control Language="VB" AutoEventWireup="false" CodeFile="HalloWeltSonst.ascx.vb" Inherits="WebParts_Adresse_HalloWeltSonst" %>   <%--CodeFile: muss auf die Quellcodedatei dieser Datei zeigen, Inherits: muss mit der Klasse in der Quellcodedatei bereinstimmen --%>
<%@ Register Assembly="myWebControls" Namespace="myWebControls" TagPrefix="cc1" %>                                                  <%--Importiert die UniERM Steuerelemente--%>

<div class="w35 left">
    <span class="first">
        <asp:Label ID="lBenutzersprache" runat="server" Text="Benutzersprache:"></asp:Label>
    </span>

    <span class="label">&nbsp;</span>
    
    <span class="last">
        <asp:Label ID="lAnrede" runat="server" Text="Anrede:"></asp:Label>
    </span>
</div>

<div class="w65 right">
    <div class="row first">
        <%--/////////Eine "ComboBox", die Datenquelle "odsSprachen" ist am Ende dieser Seite zu finden. Die Erweiterte "ComboBox" bietet standardmig das "Autocomplete-Feature"\\\\\\\\\--%>
        <cc1:myAJAXComboBox ID="macbBenutzersprache" runat="server" DataSourceID="odsSprachen" DataTextField="Bezeichnung" DataValueField="ID">
        </cc1:myAJAXComboBox>
    </div>

    <div class="row">
        <%--/////////Eine "Checkbox" mit AutoPostBack\\\\\\\\\--%>
        <cc1:myCheckbox ID="mcbIstFirma" runat="server" Text="Adresse ist eine Firma" AutoPostBack="True"></cc1:myCheckbox>
    </div>

    <div class="row last no-border"> <%--Wichtig! Die CSS-Klasse "no-border" ist fr dieses Steuerelement erforderlich--%>
        <%--/////////Eine "ComboBox" mit Neu-"Button"\\\\\\\\\--%>
        <div class="smallerLB">
            <cc1:myAJAXComboBox id="macbAnrede" runat="server" DataSourceID="odsAnrede" DataTextField="Bezeichnung" DataValueField="ID">
            </cc1:myAJAXComboBox>
        </div>
        
        <div class="LBsmaller">
            <cc1:myLinkButton ID="lbNeueAnrede" runat="server" SkinID="Neu">Neue Anrede hinzufgen</cc1:myLinkButton>
        </div>
    </div>
</div>

<%--/////////ModalPopup\\\\\\\\\--%>
<cc1:myAJAXModalPopUp ID="mampNeueTB" runat="server" SkinID="TextBox" />

<%--/////////An diese Datenquelle ist die erste "ComboBox" gebunden\\\\\\\\\--%>
<asp:ObjectDataSource ID="odsSprachen" runat="server" SelectMethod="SQLSelectQuery" TypeName="Klassen.clsDatenbank">
    <SelectParameters>
        <asp:Parameter DefaultValue="SELECT ID, Bezeichnung FROM Sprache WHERE IstGeloescht='0' ORDER BY SUBSTRING(Bezeichnung, 0, 200)" 
            Name="SQLCommandText" Type="String" />
    </SelectParameters>
</asp:ObjectDataSource>

<%--/////////An diese Datenquelle ist die zweite "ComboBox" gebunden\\\\\\\\\--%>
<asp:ObjectDataSource ID="odsAnrede" runat="server" SelectMethod="SQLSelectQuery" TypeName="ObjectDataSource_DataBoundControl">
    <SelectParameters>
        <asp:Parameter Name="SqlCommand" DefaultValue="SELECT ID, (SELECT SUBSTRING(Wert, 0, 200) AS Expr1 FROM UebersetzungsTabelle WHERE (ObjektID = Anrede.ID) AND (TabellenName LIKE 'Anrede') AND (SpaltenName LIKE 'Bezeichnung') AND (SpracheID = @param1)) AS Bezeichnung FROM Anrede ORDER BY Bezeichnung" Type="String" />
        <asp:Parameter Name="param1" DefaultValue="0" Type="String" />
    </SelectParameters>
</asp:ObjectDataSource>