<%@ Control Language="VB" AutoEventWireup="false" CodeFile="HalloWeltGridview.ascx.vb" Inherits="WebParts_Adresse_HalloWeltGridview" %> <%--CodeFile: muss auf die Quellcodedatei dieser Datei zeigen, Inherits: muss mit der Klasse in der Quellcodedatei bereinstimmen --%>
<%@ Register Assembly="myWebControls" Namespace="myWebControls" TagPrefix="cc1" %>                                                      <%--Importiert die UniERM Steuerelemente--%>

<%--/////////Gridview-Steuerelement von UniERM\\\\\\\\\--%>
<%--Datenbankzugriff: Das Gridview wird in diesem Beispiel direkt an den Datenquelle odsAnsprechpartner gebunden. Der Datenbankzugriff erfolgt ber die Datenquelle.--%>
<%--Aufbau: Der Footer des Gridviews wird in UniERM standardmssig dafr verwendet, um neue Datenstze einzupflegen. Eine Zeile, die editiert werden soll, muss vorher mit einem Button in den Editiermodus gesetzt werden. --%>
<%--Spaltendefinition: AutoGenerateColumns ist deaktiviert. Die Spalten werden ber die nachfolgenden Templates definiert. --%>
<%--Sortierung und Paging: Diese Eigenschaften sind ber den Default-Skin von UniERM automatisch aktiviert. Paging ist dabei auf 10 Zeilen gesetzt. --%>
<%--Aktionen: In der Regel ist die erste Spalte fr Aktionen, wie Editieren, Lschen, usw. vorgesehen, sodass eine einheitliche Benutzeroberflche gewhrleistet ist. --%>
<cc1:myGridview ID="mgvAnsprechpartner" runat="server" AutoGenerateColumns="False" DataSourceID="odsAnsprechpartner" ShowFooter="True">
    <Columns>
        <%--Templatespalte fr die Aktionsspalte (siehe oben) mit den Aktionsbuttons. Die Buttons nutzen das regulre Verhalten eines Gridviews und sind mit Skins von UniERM ausgestattet.--%>
        <%--Der Aufbau der Templatespalten finden sich in den nachfolgenden Templates wieder. Meistens werden Edit, Footer und Item-Template verwendet. --%>
        <%--In jedem Template liegen die entsprechenden Steuerelmente, wenn die Zeile in diesem Modus ist. Die Steuerelemente sind direkt an die Datenquelle gebunden.--%>
        <%--Um auf die Steuerelement aus dem Quellcode zuzugreifen, mssen diese dort gecastet werden (siehe Quellcodebeispiel).--%>
        <asp:TemplateField HeaderText="Aktionen" ShowHeader="False">
            <EditItemTemplate>
                <cc1:myLinkButton ID="lbSpeichern" runat="server" CommandName="lbSpeichern" CommandArgument="<%# CType(Container,GridViewRow).RowIndex %>" SkinID="Speichern" CausesValidation="True" Text="Speichern"></cc1:myLinkButton>
                <cc1:myLinkButton ID="lbAbbrechen" runat="server" CommandName="Cancel" SkinID="Abbrechen" CausesValidation="False" Text="Abbrechen"></cc1:myLinkButton>
            </EditItemTemplate>
            <FooterTemplate>
                <cc1:myLinkButton ID="lbNeu" runat="server" CommandName="lbNeu" CommandArgument="<%# CType(Container,GridViewRow).RowIndex %>" SkinID="Neu">Neu</cc1:myLinkButton>
            </FooterTemplate>
            <ItemTemplate>
                <cc1:myLinkButton ID="lbAdresseOeffnen" runat="server" CommandName="lbAdresseOeffnen" CommandArgument="<%# CType(Container,GridViewRow).RowIndex %>" SkinID="AdresseOeffnen">Adresse ffnen</cc1:myLinkButton>
                <cc1:myLinkButton ID="lbEditieren" runat="server" CommandName="Edit" CommandArgument="<%# CType(Container,GridViewRow).RowIndex %>" SkinID="Editieren" CausesValidation="False" Text="Editieren"></cc1:myLinkButton>
                <cc1:myLinkButton ID="lbLoeschen" runat="server" CommandArgument="<%# CType(Container,GridViewRow).RowIndex %>" SkinID="Loeschen" CausesValidation="False" Text="Lschen" CommandName="lbLoeschen"></cc1:myLinkButton>
            </ItemTemplate>
            <FooterStyle CssClass="middle center nbleft" />
            <HeaderStyle CssClass="ColAction2 center middle nbleft" />
            <ItemStyle CssClass="middle center nbleft" />
        </asp:TemplateField>

        <%--Unsichtbare Spalte. Der Standardskin eines Gridviews in UniERM setzt diese Spalte voraus, da hier der Datakey gespeichert wird, der beim Zugriff auf eine Zeile als Primary-Key zum Instanzieren des UniERM-Objekts genutzt wird.--%>
        <asp:BoundField DataField="ID" HeaderText="ID" InsertVisible="False" ReadOnly="True" SortExpression="ID" Visible="False" />

        <%--Templatebeispiel mit Checkbox.--%>
        <asp:TemplateField HeaderText="Post?">
            <EditItemTemplate>
                <asp:Panel ID="pPost" runat="server" DefaultButton="lbSpeichern">
                    <cc1:myCheckbox ID="mcbPost" runat="server" Checked='<%# Bind("post") %>'></cc1:myCheckbox>
                </asp:Panel>
            </EditItemTemplate>
            <FooterTemplate>
                <asp:Panel ID="pPost" runat="server" DefaultButton="lbNeu">
                    <cc1:myCheckbox ID="mcbPost" runat="server" Checked='<%# Bind("post") %>'></cc1:myCheckbox>
                </asp:Panel>
            </FooterTemplate>
            <ItemTemplate>
                <asp:Panel runat="server" ID="pPost" Enabled="false">
                    <cc1:myCheckbox ID="mcbPost" runat="server" Enabled="False" Checked='<%# Bind("post") %>'></cc1:myCheckbox>
                </asp:Panel>
            </ItemTemplate>
            <HeaderStyle CssClass="ColPost" />
        </asp:TemplateField>

        <%--Templatebeispiel mit Dropdown. Die Dropdown ist hier ebenfalls an eine Datenquelle (odsAnrede) gebunden, damit diese mit Werten gefllt wird. --%>
        <asp:TemplateField HeaderText="Anrede" SortExpression="Anrede">
            <EditItemTemplate>
                <cc1:myAJAXComboBox ID="macbAnrede" runat="server" DataSourceID="odsAnrede" DataTextField="Bezeichnung" DataValueField="ID" AppendDataBoundItems="True" SelectedValue='<%# Bind("AnredeID") %>'>
                    <asp:ListItem></asp:ListItem>
                </cc1:myAJAXComboBox>
            </EditItemTemplate>
            <FooterTemplate>
                <cc1:myAJAXComboBox ID="macbAnrede" runat="server" DataSourceID="odsAnrede" DataTextField="Bezeichnung" DataValueField="ID" AppendDataBoundItems="True" SelectedValue='<%# Bind("AnredeID") %>'>
                    <asp:ListItem></asp:ListItem>
                </cc1:myAJAXComboBox>
            </FooterTemplate>
            <ItemTemplate>
                <asp:Label ID="lAnrede" runat="server" Text='<%# Bind("Anrede") %>'></asp:Label>
            </ItemTemplate>
            <HeaderStyle CssClass="ColAnrede" />
        </asp:TemplateField>

        <%--Templatebeispiel mit Textbox.--%>
        <asp:TemplateField HeaderText="Name1 (Nachname)" SortExpression="Name1">
            <EditItemTemplate>
                <asp:Panel ID="pName1" runat="server" DefaultButton="lbSpeichern">
                    <cc1:myAJAXTextBox ID="matbName1" runat="server" Text='<%# Bind("Name1") %>' DivWithFakeBorder="True">
                    </cc1:myAJAXTextBox>
                </asp:Panel>
            </EditItemTemplate>
            <FooterTemplate>
                <asp:Panel ID="pName1" runat="server" DefaultButton="lbNeu">
                    <cc1:myAJAXTextBox ID="matbName1" runat="server" Text='<%# Bind("Name1") %>' DivWithFakeBorder="True">
                    </cc1:myAJAXTextBox>
                </asp:Panel>
            </FooterTemplate>
            <ItemTemplate>
                <asp:Label ID="lName1" runat="server" Text='<%# Bind("Name1") %>'></asp:Label>
            </ItemTemplate>
            <HeaderStyle CssClass="ColName" />
        </asp:TemplateField>

        <%--Flltemplate damit das Gridview auf kompletter Webpartbreite angezeigt wird. Diese Spalte sollte immer als letztes hinzugefgt werden. --%>
        <asp:TemplateField>
            <FooterStyle CssClass="nbleft nbright" />
            <HeaderStyle CssClass="nbleft nbright" />
            <ItemStyle CssClass="nbleft nbright" />
        </asp:TemplateField>
    </Columns>
</cc1:myGridview>

<%--Die Datenquelle, die an die Dropdown im Gridview gebunden ist. --%>
<%--Beide Datenquellen nutzen die SQLSelectQuery Funktion von UniERM, um auf die Datenbank zuzugreifen. --%>
<%--In dem Parameter SqlCommand steht der entsprechende Datenbankbefehl, der die Daten abruft. --%>
<%--ber den Sessionparameter werden die Anrede in der richtigen Sprache angezeigt. --%>
<asp:ObjectDataSource ID="odsAnrede" runat="server" SelectMethod="SQLSelectQuery" TypeName="ObjectDataSource_DataBoundControl"> 
    <SelectParameters>
        <asp:Parameter Name="SqlCommand" DefaultValue="SELECT ID, (SELECT SUBSTRING(Wert, 0, 200) AS Expr1 FROM UebersetzungsTabelle WHERE (ObjektID = Anrede.ID) AND (TabellenName LIKE 'Anrede') AND (SpaltenName LIKE 'Bezeichnung') AND (SpracheID = @param1)) AS Bezeichnung FROM Anrede ORDER BY Bezeichnung" Type="String" />
        <asp:SessionParameter DefaultValue="0" Name="param1" SessionField="GlobaleSpracheID" Type="String" />
    </SelectParameters>
</asp:ObjectDataSource>

<%--Die Datenquelle, die an das Gridview gebunden ist. --%>
<%--Im Vergleich zu der Datenquelle odsAnrede wird hier zustzlich auf den Querystring der Adresszeile als Parameter zugegriffen, um auslesen, von welcher Adresse (ID) die Ansprechpartner ausgelesen werden sollen.--%>
<asp:ObjectDataSource ID="odsAnsprechpartner" runat="server" SelectMethod="SQLSelectQuery" TypeName="ObjectDataSource_DataBoundControl">
    <SelectParameters>
        <asp:Parameter Name="SqlCommand" DefaultValue="SELECT DISTINCT Adresse.ID, Adresse.post, (SELECT SUBSTRING(Wert, 0, 200) AS Expr1 FROM UebersetzungsTabelle WHERE (ObjektID = Anrede.ID) AND (TabellenName LIKE 'Anrede') AND (SpaltenName LIKE 'Bezeichnung') AND (SpracheID = @param1)) AS Anrede, Adresse.Name1, Anrede.ID AS AnredeID FROM Adresse LEFT OUTER JOIN Anrede ON Adresse.StandardAnredeID = Anrede.ID WHERE (Adresse.ID IN (SELECT AnsprechpartnerID FROM AdresseAnsprechpartner AS AdresseAnsprechpartner_1 WHERE (AdresseID = @param2))) AND (Adresse.IstGeloescht = '0') ORDER BY Adresse.Name1" Type="String" />
        <asp:SessionParameter DefaultValue="0" Name="param1" SessionField="GlobaleSpracheID" Type="String" />
        <asp:QueryStringParameter DefaultValue="0" Name="param2" QueryStringField="ID" Type="String" />
    </SelectParameters>
</asp:ObjectDataSource>
