<%@ Control Language="VB" AutoEventWireup="false" CodeFile="HalloWeltTreeViewCT.ascx.vb" Inherits="WebParts_Vorgang_HalloWeltTreeViewCT" %>                     <%--CodeFile: muss auf die Quellcodedatei dieser Datei zeigen, Inherits: muss mit der Klasse in der Quellcodedatei bereinstimmen --%>
<%@ Register Assembly="myWebControls" Namespace="myWebControls" TagPrefix="cc1" %>                                                                              <%--Importiert die UniERM Steuerelemente--%>
<%@ Register Src="../../../JQueryTreeview.ascx" TagName="JQueryTreeview" TagPrefix="uc1" %>                                                                     <%--Relativer Pfad zum "JQueryTreeview"-Steuerelement--%>

<asp:Panel ID="pTreeview" runat="server" CssClass="toolboxTree">                                                                                                <%--Die CSS-Klasse "toolboxTree" stellt sicher, dass die Treeviews zueinander richtig ausgerichtet werden--%>
    <div class="w50 left">
        <asp:Panel ID="TreeviewScrollContainer" runat="server" CssClass="TreeviewScrollContainer JSWPMaximizeable">                                             <%--Dieses "Panel/Div" dient, mithilfe der ber die CSS-Klassen aktivierten Javascripte dazu, das Webpart maximierbar zu machen, sowie die Scrollposition bei lngeren Treeviews ber einen "Pageload" hinweg zu bewahren--%>
            <uc1:JQueryTreeview ID="JQueryTreeview" runat="server">
                <DefaultTemplate>
                </DefaultTemplate>
                <%--/////////Die folgenden Templates werden benutzt um innerhalb des Treeviews ein Gridview darzustellen\\\\\\\\\--%>
                <Template1>
                    <div class="OneLineStyle JSGrAlign" AlignID="1"> <%--Die CSS-Klasse "OneLineStyle" verhindert, dass die Zeile der "Node" umbricht. Die CSS-Klasse "JSGrAlign" aktiviert das ausrichten der Gridview-Rows zueinander. Die AlignID bestimmt welche Gridview-Rows zueinander gehren--%>
                        <%--/////////Der Header ist genauso wie bei einem normalen Gridview aufgebaut, es knnen die gleichen CSS-Klassen genutzt werden\\\\\\\\\--%>
                        <table class="Gridview" style="height: 23px;">
                            <tbody>
                                <tr class="head">
                                    <th class="nbleft treegrid ColAction">Aktionen</th>
                                    <th class="nbright treegrid ColArtikelbezeichnung">Artikel</th>
                                    <th class="nbright treegrid ColAnzahl">Menge</th>
                                    <th class="nbleft nbright treegrid">&nbsp</th>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </Template1>
                <%--/////////Es werden zwei Templates fr die Zeilen bentigt um einen sich abwechselnden Hintergrund bei den Zeilen darzustellen\\\\\\\\\--%>
                <Template2>
                    <div class="OneLineStyle JSGrAlign draggMe" AlignID="1">
                        <table class="Gridview" style="height: 23px;">
                            <tbody>
                                <tr class="odd">
                                    <td class="nbleft ColAction">
                                        <cc1:myLinkButton ID="MyLinkButtonEditieren" runat="server" SkinID="Editieren">Bearbeiten</cc1:myLinkButton>
                                        <cc1:myLinkButton ID="MyLinkButtonDelete" runat="server" SkinID="Loeschen">Lschen</cc1:myLinkButton>
                                    </td>
                                    <td class="nbright ColArtikelbezeichnung">
                                        <asp:Label id="lArtikel" runat="server" Text='' Style="bottom: 0px;"></asp:Label>
                                    </td>
                                    <td class="nbright ColAnzahl">
                                        <asp:Label id="lMenge" runat="server" Text='' Style="bottom: 0px;"></asp:Label>
                                    </td>
                                    <td class="nbleft nbright">&nbsp</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </Template2>
                <Template3>
                    <div class="OneLineStyle JSGrAlign draggMe" AlignID="1">
                        <table class="Gridview" style="height: 23px;">
                            <tbody>
                                <tr class="even">
                                    <td class="nbleft ColAction">
                                        <cc1:myLinkButton ID="MyLinkButtonEditieren" runat="server" SkinID="Editieren">Bearbeiten</cc1:myLinkButton>
                                        <cc1:myLinkButton ID="MyLinkButtonDelete" runat="server" SkinID="Loeschen">Lschen</cc1:myLinkButton>
                                    </td>
                                    <td class="nbright ColArtikelbezeichnung">
                                        <asp:Label id="lArtikel" runat="server" Text='' Style="bottom: 0px;"></asp:Label>
                                    </td>
                                    <td class="nbright ColAnzahl">
                                        <asp:Label id="lMenge" runat="server" Text='' Style="bottom: 0px;"></asp:Label>
                                    </td>
                                    <td class="nbleft nbright">&nbsp</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </Template3>
                <%--/////////Wenn eine Zeile ausgewhlt wird, werden Eingabemglichkeiten zur Verfgung gestellt\\\\\\\\\--%>
                <SelectedTemplate2>
                    <div class="OneLineStyle JSGrAlign draggMe" AlignID="1">
                        <table class="Gridview" style="height: 23px;">
                            <tbody>
                                <tr class="odd">
                                    <td class="nbleft ColAction">
                                        <cc1:myLinkButton ID="MyLinkButtonSpeichern" runat="server" SkinID="Speichern">Speichern</cc1:myLinkButton>
                                        <cc1:myLinkButton ID="MyLinkButtonAbbrechen" runat="server" SkinID="Abbrechen">Artikel ffnen</cc1:myLinkButton>
                                    </td>
                                    <td class="nbright ColArtikelbezeichnung">
                                        <asp:Label id="lArtikel" runat="server" Text='' Style="bottom: 0px;"></asp:Label>
                                    </td>
                                    <td class="nbright ColAnzahl">
                                        <div class="OneLineStyle" Style="margin-top: -5px;">
                                            <cc1:myAJAXTextBox ID="matbMenge" runat="server" DivWithFakeBorder="True" SkinID="Double" />
                                        </div>
                                    </td>
                                    <td class="nbleft nbright">&nbsp</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </SelectedTemplate2>
                <SelectedTemplate3>
                    <div class="OneLineStyle JSGrAlign draggMe" AlignID="1">
                        <table class="Gridview" style="height: 23px;">
                            <tbody>
                                <tr class="even">
                                    <td class="nbleft ColAction">
                                        <cc1:myLinkButton ID="MyLinkButtonSpeichern" runat="server" SkinID="Speichern">Speichern</cc1:myLinkButton>
                                        <cc1:myLinkButton ID="MyLinkButtonAbbrechen" runat="server" SkinID="Abbrechen">Artikel ffnen</cc1:myLinkButton>
                                    </td>
                                    <td class="nbright ColArtikelbezeichnung">
                                        <asp:Label id="lArtikel" runat="server" Text='' Style="bottom: 0px;"></asp:Label>
                                    </td>
                                    <td class="nbright ColAnzahl">
                                        <div class="OneLineStyle" Style="margin-top: -5px;">
                                            <cc1:myAJAXTextBox ID="matbMenge" runat="server" DivWithFakeBorder="True" SkinID="Double" />
                                        </div>
                                    </td>
                                    <td class="nbleft nbright">&nbsp</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </SelectedTemplate3>
            </uc1:JQueryTreeview>
        </asp:Panel>
        <%--/////////Der "TreeviewFooter" enthlt die Zeile unter dem Haupt-Treeview, welche dazu dient (in diesem Fall) neue Positionen anzulegen\\\\\\\\\--%>
        <div class="TreeviewFooter" style="height:40px;">
            <uc1:JQueryTreeview ID="JQueryTreeviewNeu" runat="server">
                <DefaultTemplate>
                    <div class="OneLineStyle draggMe"> <%--Die CSS-Klasse "draggMe" ermglicht es "DIVs" als "Anfasspunkt" fr die Maus zum ziehen der "Node" zu dienen--%>
                        <cc1:myLinkButton ID="MyLinkButtonMove" runat="server" SkinID="Move">Verschieben</cc1:myLinkButton>
                    </div>
                    <div class="OneLineStyle draggMe">
                        <asp:Label id="lText" runat="server" Text='Neue Position (Menge,Artikel):'></asp:Label>
                    </div>
                    <div class="OneLineStyle" style="width:60px">
                        <cc1:myAJAXTextBox ID="matbMenge" runat="server" DivWithFakeBorder="True"  SkinID="Double" />
                    </div>
                    <asp:Panel runat="server" ID="pNeu" CssClass="OneLineStyle" style="width:200px;" Enabled="true">
                        <div class="smallerLB">
                            <cc1:myAJAXTextBox ID="matbArtikel" runat="server"  SkinID="AutoComplete" ServiceMethod="GetArtikel" DivWithFakeBorder="True" />
                        </div>
                        <div class="LBsmaller" style="margin-right:3px;">
                            <cc1:myLinkButton ID="MyLinkButtonNeu" runat="server" SkinID="Neu">Neu</cc1:myLinkButton>
                        </div>
                    </asp:Panel>
                    <asp:Label id="lLeer" runat="server" Text='&nbsp;'></asp:Label>
                </DefaultTemplate>
            </uc1:JQueryTreeview>
        </div>
    </div>

    <%--/////////Dieses "Panel/Div" dient, mithilfe der ber die CSS-Klassen aktivierten Javascripte dazu, das Webpart maximierbar zu machen, sowie die Scrollposition bei lngeren Treeviews ber einen "Pageload" hinweg zu bewahren\\\\\\\\\--%>
    <asp:Panel ID="TreeviewScrollContainerToolbox" runat="server" CssClass="TreeviewScrollContainer TreeToolboxContainer JSWPMaximizeable">                     
        <%--/////////Die "TreeviewToolbox" wird auf der rechten Seite angezeigt und enthlt in diesem Fall Artikel und Adressen\\\\\\\\\--%>
        <uc1:JQueryTreeview ID="JQueryTreeviewToolbox" runat="server">
                <Template1>
                    <cc1:myLinkButton ID="MyLinkButtonNodesLaden" runat="server" SkinID="NodesLaden">Nodes laden</cc1:myLinkButton>
                </Template1>
        </uc1:JQueryTreeview>
    </asp:Panel>
</asp:Panel>
