﻿Imports globalefunktionen

Partial Class WebParts_Adresse_HalloWeltPK 'Die Klasse des Webparts muss mit der Angabe in der ".ascx"-Datei übereinstimmen, außerdem Bestimmt der Klassenname ob das Webpart z.B. ein anderes Webpart überschreibt. (Falls z.B. das Webpart "Anschrift.ascx" überschrieben werden soll würde die Klasse "WebParts_Adresse_WPAnschrift" sein)
    Inherits myWebControls.myWebPart

#Region " Besipiele "

    ''' <summary>
    ''' Prozedur für spezielle Nachbehandlungen nach dem Hinzufügen von Adressen zum Vorgang
    ''' </summary>
    ''' <remarks>ACHTUNG! Wird nur für Webparts im Ordner "/WebParts/MostSpecific/Adresse/" ausgeführt!</remarks>
    Public Overrides Sub PostVorgangAdresseHinzufuegen(VorgangID As Integer, AdresseID As Integer)
        MyBase.PostVorgangAdresseHinzufuegen(VorgangID, AdresseID)

        Dim Vorgang As New Klassen.clsVorgangClient(VorgangID)
        Dim Adresse As New Klassen.clsAdresse(AdresseID)

        'Testweise wird hier nach dem Hinzufügen einer Adresse zum Vorgang der Name1 und Name2 in die Bezeichnung des Vorgangs geschrieben:
        If Not Vorgang Is Nothing AndAlso Not Adresse Is Nothing Then
            Vorgang.Bezeichnung = Adresse.Name1 & Adresse.Name2
        End If

        '! Wählen Sie einfach auf einem Vorgang eine neue Adresse im Webpart 'Adresse' aus, drücken Sie den Speichern-"Button" und im Webpart 'Vorgangsinformationen' oder 'Fortgeschritten - 01 MyAJAXTextBox' unter Bezeichnung sollte der Name stehen.
    End Sub

#Region " weitere "

    ''' <summary>
    ''' Prozedur für spezielle Nachbehandlungen nach dem Kopieren von Vorgängen
    ''' </summary>
    ''' <remarks>ACHTUNG! Wird nur für Webparts im Ordner "/WebParts/MostSpecific/Vorgang/" ausgeführt!</remarks>
    Public Overrides Sub PostVorgangKopieren(QuellVorgangID As Integer, ZielVorgangID As Integer, IndividuenMitKopieren As Boolean, PositionMitKopieren As Boolean)
        MyBase.PostVorgangKopieren(QuellVorgangID, ZielVorgangID, IndividuenMitKopieren, PositionMitKopieren)

    End Sub

    ''' <summary>
    ''' Prozedur für spezielle Nachbehandlungen nach dem Kopieren von Artikeln
    ''' </summary>
    ''' <param name="QuellArtikelID"></param>
    ''' <param name="ZielArtikelID"></param>
    ''' <remarks>ACHTUNG! Wird nur für Webparts im Ordner "/WebParts/MostSpecific/Artikel/" ausgeführt!</remarks>
    Public Overrides Sub PostArtikelKopieren(QuellArtikelID As Integer, ZielArtikelID As Integer)
        MyBase.PostArtikelKopieren(QuellArtikelID, ZielArtikelID)

    End Sub

    ''' <summary>
    ''' Prozedur für spezielle Nachbehandlungen nach dem Hinzufügen von Artikeln zum Vorgang
    ''' </summary>
    ''' <remarks>ACHTUNG! Wird nur für Webparts im Ordner "/WebParts/MostSpecific/Artikel/" ausgeführt!</remarks>
    Public Overrides Sub PostVorgangsPositionClientArtikelHinzufuegen(VorgangsPositionClientID As Integer, ArtikelID As Integer)
        MyBase.PostVorgangsPositionClientArtikelHinzufuegen(VorgangsPositionClientID, ArtikelID)

    End Sub

    ''' <summary>
    ''' Prozedur für spezielle Nachbehandlungen nach dem Export von Daten (über den Export-"Button"). Diese Prozedur wird z.B. genutzt um Artikel als Exportiert zu markieren.
    ''' </summary>
    ''' <remarks></remarks>
    Public Overrides Sub PostExport()
        MyBase.PostExport()

    End Sub

#End Region

#End Region

#Region " In diesem Beispiel nicht relevant "

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property CatalogIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Beschreibungstext für das Webpart angegeben werden, welcher im Dialog "Webpart hinzufügen" angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Description() As String
        Get
            Return "Hier steht die Beschreibung"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wird Nach dem Titel in der Titelzeile und im Dialog "Webpart hinzufügen" angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property Subtitle() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' Der Titel des Webparts wird in der Titelzeile, im Dialog "Webpart hinzufügen" und an weiteren Stellen angezeigt angezeigt
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property Title() As String
        Get
            Return "Fortgeschritten - 09 Funktionen nach Artikel, Vorgang, Adresse kopieren"
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Bild angegeben werden, welches in der Titelzeile des Webparts angezeigt wird
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleIconImageUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Hier kann ein Webadresse angegeben werden, welche die Titelleiste in einen Link umwandelt, diese Funktion wird allerdings bisher nicht verwendet
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides Property TitleUrl() As String
        Get
            Return ""
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    ''' <summary>
    ''' Wenn hier eine Webadresse angegeben wird, erscheint das Hilfe-Symbol in der Titelzeile und leitet den Benutzer, wenn geklickt, auf die jeweilige Webadresse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Overrides ReadOnly Property HelpUrl() As String
        Get
            Return ""
        End Get
    End Property

    ''' <summary>
    ''' In diesem Beispiel nicht relevant
    ''' </summary>
    ''' <param name="session"></param>
    ''' <remarks></remarks>
    Public Overrides Sub SaveDataToSession(ByVal session As System.Web.SessionState.HttpSessionState)
    End Sub

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten aus dem aktuellen Klassen-Objekt zu laden.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub LoadDataFromKlassenObjekt()
    End Sub

    ''' <summary>
    ''' Diese Funktion wird benutzt um Daten in das aktuelle Klassen-Objekt zu speichern.
    ''' </summary>
    ''' <remarks></remarks>
    Protected Overrides Sub SaveDataToKlassenObjekt()
    End Sub

#End Region

End Class