<%@ Control Language="VB" AutoEventWireup="false" CodeFile="HalloWelt.ascx.vb" Inherits="WebParts_Adresse_HalloWelt" %> <%--CodeFile: muss auf die Quellcodedatei dieser Datei zeigen, Inherits: muss mit der Klasse in der Quellcodedatei bereinstimmen --%>
<%@ Register Assembly="myWebControls" Namespace="myWebControls" TagPrefix="cc1" %>                                      <%--Importiert die UniERM Steuerelemente--%>

<div class="w35 left">                                                                                                  <%--Erzeugt den fr ein Standardwebpart typischen Beschreibungsbereich fr die Steuerlemente, es sind auch andere/eigene Aufteilungen mglich--%>
    <span class="first">                                                                                                <%--Das erste Beschriftungselement muss explizit gekennzeichnet werden, um per CSS korrekt ausgerichtet werden zu knnen--%>
        <asp:Label ID="lTelefon" runat="server" Text="Telefon:"></asp:Label>                                            <%--Ein einfaches Beschriftungselement--%>
    </span>

    <asp:Label ID="lGeburtstagdatum" runat="server" Text="Geburtstag:"></asp:Label>                                             

    <span class="last">                                                                                                 <%--Das letzte Beschriftungselement muss explizit gekennzeichnet werden, um per CSS korrekt ausgerichtet werden zu knnen--%>
        <asp:Label ID="lInternet" runat="server" Text="Internet:"></asp:Label>                                          
    </span>
</div>

<div class="w65 right">                                                                                                 <%--Erzeugt den fr ein Standardwebpart typischen Steuerlementbereich, es sind auch andere/eigene Aufteilungen mglich--%>
    <div class="row first">                                                                                             <%--Das erste Steuerlement muss explizit gekennzeichnet werden, um per CSS korrekt ausgerichtet werden zu knnen--%>
        <cc1:MyAJAXTextBox ID="matbTelefon" runat="server" DivWithFakeBorder="True" MaxLength="100" />                  <%--Eine erweiterte Textbox, welche diverse Sonderfunktionen zur normalen Textbox bietet--%>
    </div>
    
    <div class="row">
        <cc1:MyAJAXTextBox ID="matbGeburtstagdatum" runat="server" SkinID="Date" DivWithFakeBorder="true" />            <%--Diese Textbox wird durch den "Skin" "Date" zusammen mit einer Datumsauswahl angezeigt und lsst zudem nur Datumswerte zu--%>
    </div>                                                                                                              <%--Die "Skins" lassen sich fr die Textbox unter "\App_Themes\Main\myAJAXTextBox.skin" finden--%>
        
    <div class="row last">                                                                                              <%--Das letzte Steuerlement muss explizit gekennzeichnet werden, um per CSS korrekt ausgerichtet werden zu knnen--%>
        <cc1:MyAJAXTextBox ID="matbInternet" runat="server" DivWithFakeBorder="True" MaxLength="100" ReadOnly="True" /> <%--Diese Textbox kann nur gelesen werden--%>
    </div>
</div>
